// Utilities
// Diyouware TwinTeeth mini-PCB factory,
// Copyright 2015 by V.Aylln.
//
enum { NO = 0, YES = 1 };
enum { false = 0, true = 1 };
enum { TOP = 0, BOTTOM = 1 };

int MAX_DRILL_BITS = 4;
int ERROR = -1;

int current_layer = TOP;
string temp = "";
string text_buffer = "";
string smd_name[];	   // Smd name
int x[], y[];		   // drill and smd coordinates
real e[];			   // extruder coord.
int tb[];              // top or bottom side
int bit_active[];	   // if we found holes for this bit
real drill_size_mm[];     // hole size in mm
int index[];		   // index
int vindex[];		   // index
int drill_index = 0;

string dispense_filename = "";
string fillvias_filename = "";
string blindvias_filename = "";
string drill_filename = "";
string board_name = "";	   // board name
string ulp_path = "";


void write_bool_param(string name, int value) 
{
  printf("int %s = %s;\n", name, (value) ? "1" : "0");
}

void write_int_param(string name, int value) 
{
  printf("int %s = %d;\n", name, value);
}

void write_int_defined(string name, string value) 
{
  printf("int %s = %s;\n", name, value);
}

void write_real_param(string name, real value) 
{
  printf("real %s = %f;\n", name, value);
}

void write_string_param(string name, string value) 
{
  printf("string %s = \"%s\";\n", name, value);
}

void write_bool_array_param(string name, int n) 
{
	printf("int %s[] = {",name);
	for (int i = 0; i < n; i++){
		if (name == "DRILL_BIT")
			printf("%d", DRILL_BIT[i]);
		else printf("%d,", 0);
		if (i != n-1)
			printf(",");
	}
	printf("};\n");
}

void write_real_array_param(string name, int n) 
{
	printf("real %s[] = {",name);
	for (int i = 0; i < n; i++){
		if (name == "DRILL_SIZE")
			printf("%f", DRILL_SIZE[i]);
		else if (name == "MIN_DRILL_SIZE")
			printf("%f", MIN_DRILL_SIZE[i]);
		else if (name == "MAX_DRILL_SIZE")
			printf("%f", MAX_DRILL_SIZE[i]);
		else printf("%f", 0);
		if (i != n-1)
			printf(",");
	}
	printf("};\n");
}


void get_path()
{
  int index = 0;

  while (path_ulp[index] != "" && index < 10) {
    if(filetime(path_ulp[index] + "/twinteeth-resources/defaults.h")) {
      ulp_path = path_ulp[index];
      return;
    }
    index++;
  }
}


void get_board_name()
{
	if (board) {
		board(B) {
			board_name = B.name;
		}
	}
	else {
		dlgMessageBox("\n    Please, start this ULP in a Board    \n");
		exit (0);
	}
}


// Scale X. Negative for bottom, positive top.
real scale_x(int x)
{
	real value;

	value = u2mm(x);
	if (current_layer == BOTTOM && MIRROR_BOTTOM_DRILL == NO) 
		value = value * -1;

	return value;
}

// Scale Y. Negative for bottom, positive top.
real scale_y(int y)
{
	real value;

	value = u2mm(y);
	if (current_layer == BOTTOM && MIRROR_BOTTOM_DRILL == NO) 
		value = value * -1;

	return value;
}

void show_error(string msg, string reason)
{
	dlgMessageBox("<hr><b>Error: " + msg + "</b><p>" + reason);

}


string real_to_string(real n)
{
	sprintf(temp, "%f", n);
	return temp;
}

void clean_bits_active(){
	for (int i = 0; i < MAX_DRILL_BITS; i++)
		bit_active[i] = NO;
}